
From: Shaohua Li <shaohua.li@intel.com>

In the cpu hotplug case, per-cpu data possibly isn't initialized even the
system state is 'running'.  As the comments say in the original code, some
console drivers assume per-cpu resources have been allocated.  radeon fb is
one such driver, which uses kmalloc.  After a CPU is down, the per-cpu data
of slab is freed, so the system crashed when printing some info.

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 kernel/printk.c |    3 +--
 1 files changed, 1 insertion(+), 2 deletions(-)

diff -puN kernel/printk.c~cpu-hotplug-printk-fix kernel/printk.c
--- 25/kernel/printk.c~cpu-hotplug-printk-fix	2005-05-26 22:43:09.000000000 -0700
+++ 25-akpm/kernel/printk.c	2005-05-26 22:43:09.000000000 -0700
@@ -588,8 +588,7 @@ asmlinkage int vprintk(const char *fmt, 
 			log_level_unknown = 1;
 	}
 
-	if (!cpu_online(smp_processor_id()) &&
-	    system_state != SYSTEM_RUNNING) {
+	if (!cpu_online(smp_processor_id())) {
 		/*
 		 * Some console drivers may assume that per-cpu resources have
 		 * been allocated.  So don't allow them to be called by this
_
